<?php
/**
 * Template Name: Blog
 *
 * @package WordPress
 * @subpackage SaaS_I_Theme
 *
 * Copyright (c) 2010 WorryFreeLabs
 *
 * This file is part of SaaS I WordPress theme
 */

get_header() ?>

			</div>
		</div>
	</div>
</div>
<!--div.header end -->

<div class="container">
	<div class="center">
		<?php get_sidebar() ?>
		<div id="content" class="col-main">
			<?php query_posts('posts_per_page=' . get_option('posts_per_page')) ?>
			<?php if (have_posts()): ?>
				<?php while (have_posts()): the_post() ?>
					<div <?php post_class() ?>>
						<div class="thumbnail">
							<a href="<?php the_permalink() ?>" rel="bookmark" title="<?php printf(esc_attr__('Permanent Link to %s', 'saas'), the_title_attribute('echo=0')) ?>">
							<?php if (has_post_thumbnail()): ?>
								<?php the_post_thumbnail() ?>
							<?php else: ?>
								<img class="thumb" src="<?php bloginfo('template_url') ?>/images/thumb.jpg" alt="" />
							<?php endif ?>
							</a>
						</div>
						<div>
							<h3><a href="<?php the_permalink() ?>" rel="bookmark" title="<?php printf(esc_attr__('Permanent Link to %s', 'saas'), the_title_attribute('echo=0')) ?>"><?php the_title() ?></a></h3>
							<div class="postmeta">
								<div class="comment-stats right"><?php comments_popup_link(__('0 Comments', 'saas'), __('1 Comment', 'saas'), __('% Comments', 'saas')) ?></div>
								<div class="tags"><?php printf(__('Posted on <strong>%1$s</strong> in %2$s', 'saas'), get_the_time('F j, Y'), get_the_category_list(', ')) ?></div>
							</div>
							<div class="entry">
								<?php the_excerpt() ?>
								<p><a href="<?php the_permalink() ?>" class="keep-reading" rel="bookmark" title="<?php printf(esc_attr__('Permanent Link to %s', 'saas'), the_title_attribute('echo=0')) ?>"><?php esc_html_e('Keep Reading', 'saas') ?></a></p>
							</div>
						</div>
					</div>
				<?php endwhile ?>
		
				<?php if (function_exists('wp_pagenavi')): ?>
					<?php wp_pagenavi() ?>
				<?php else: ?>
					<div class="navigation">
						<div class="alignleft">
							<?php next_posts_link(__('&laquo; Older Entries', 'saas')) ?>
						</div>
						<div class="alignright">
							<?php previous_posts_link(__('Newer Entries &raquo;', 'saas')) ?>
						</div>
					</div>
				<?php endif ?>
			
			<?php else: ?>
				
				<div class="post">
					<h2><?php esc_html_e('No posts found. Try a different search?', 'saas') ?></h2>
					<p><?php esc_html_e('Sorry, but you are looking for something that isn\'t here.', 'saas') ?></p>
					
					<div class="widget widget_search">
						<?php get_search_form() ?>
					</div>
				</div>
				
			<?php endif ?>
			
		</div>

<?php get_footer() ?>