<?php
/**
 * @package WordPress
 * @subpackage SaaS_I_Theme
 *
 * Copyright (c) 2010 WorryFreeLabs
 *
 * This file is part of SaaS I WordPress theme
 */

// Do not delete these lines
if (!empty($_SERVER['SCRIPT_FILENAME']) && 'comments.php' == basename($_SERVER['SCRIPT_FILENAME']))
	die (__('Please do not load this page directly. Thanks!', 'saas'));

if ( post_password_required() ) { ?>
	<p><?php esc_html_e('This post is password protected. Enter the password to view comments.', 'saas') ?></p>
<?php
	return;
}

function custom_comment($comment, $args, $depth)
{
	$GLOBALS['comment'] = $comment;
	?>
	<li>
		<div id="comment-<?php comment_ID() ?>">
			<div class="comment-meta">
				<span class="comment-author left"><?php printf(__('%s', 'saas'), get_comment_author_link()) ?></span>
				<span class="comment-date right"><?php printf(__('%1$s at %2$s', 'saas'), get_comment_date(), get_comment_time()) ?></span>
			</div>
			<div class="comment-content">
				<?php if ($comment->comment_approved == '0') : ?>
					<p><em><?php esc_html_e('Your comment is awaiting moderation.', 'saas') ?></em></p>
				<?php endif ?>
				<?php comment_text() ?>
				<?php comment_reply_link(array_merge($args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
			</div>
		</div>
	<?php
}

?>

<!-- You can start editing here. -->
<div id="respond">

<?php if ( have_comments() ) : ?>
	<div class="comments-box"><h3><?php comments_number(__('0 Comments', 'saas'), __('1 Comment', 'saas'), __('% Comments', 'saas')) ?></h3>


	<ol class="commentlist">
		<?php wp_list_comments('type=comment&callback=custom_comment') ?>
	</ol>
</div>
 <?php else : // this is displayed if there are no comments so far ?>

	<?php if ( comments_open() ) : ?>
		<!-- If comments are open, but there are no comments. -->

	<?php else : // comments are closed ?>
		<!-- If comments are closed. -->
		<div class="comments-box"><p></p></div>

	<?php endif ?>
<?php endif ?>


<?php if ( comments_open() ) : ?>

<div class="contactForm radius">
	<h3><?php comment_form_title(__('Leave a Reply', 'saas')) ?></h3>

<p class="cancel-reply item">
	<?php cancel_comment_reply_link() ?>
</p>

<?php if ( get_option('comment_registration') && !is_user_logged_in() ) : ?>
	<p class="item"><?php printf(__('You must be <a href="%s">logged in</a> to post a comment.', 'saas'), wp_login_url(get_permalink())) ?></p>
<?php else : ?>

<form action="<?php echo get_option('siteurl') ?>/wp-comments-post.php" method="post" id="commentform">

<?php if ( is_user_logged_in() ) : ?>

<div class="item">
	<?php printf(__('Logged in as <a href="%1$s">%2$s</a>.', 'saas'), get_option('siteurl') . '/wp-admin/profile.php', $user_identity) ?>
	<a href="<?php echo wp_logout_url(get_permalink()) ?>" title="<?php esc_attr_e('Log out of this account', 'saas') ?>"><?php _e('Log out &raquo;', 'saas') ?></a>
</div>

<?php else : ?>

<div class="half left"><label for="author"><?php _e('Your Name', 'saas') ?> <?php if ($req) echo "*" ?></label>
<input type="text" name="author" id="author" value="<?php echo esc_attr($comment_author) ?>" size="22" tabindex="1" <?php if ($req) echo "aria-required='true'" ?> />
</div>

<div class="half right"><label for="email"><?php _e('Your Email Address', 'saas') ?> <?php if ($req) echo "*" ?></label>
<input type="text" name="email" id="email" value="<?php echo esc_attr($comment_author_email) ?>" size="22" tabindex="2" <?php if ($req) echo "aria-required='true'" ?> />
</div>

<?php endif ?>

<!--<p><small><strong>XHTML:</strong> <?php _e('You can use these tags', 'saas') ?>: <code><?php echo allowed_tags() ?></code></small></p>-->

<div class="item">
<label><?php _e('Your Comment', 'saas') ?></label>
<textarea name="comment" id="comment" cols="100%" rows="10" tabindex="4"></textarea></div>

<div class="item a-right"><input name="submit" type="submit" value="<?php esc_attr_e('Submit Comment', 'saas') ?>" />
<?php comment_id_fields() ?>
</div>
<?php do_action('comment_form', $post->ID) ?>

</form>

<?php endif; // If registration required and not logged in ?>
</div>

<?php endif; // if you delete this the sky will fall on your head ?>

</div><!-- div#respond -->