<?php
/**
 * @package WordPress
 * @subpackage SaaS_I_Theme
 *
 * Copyright (c) 2010 WorryFreeLabs
 *
 * This file is part of SaaS I WordPress theme
 */



// Plans generator
$plansList = array();

$parsedPlans = array();
preg_match_all('%(.?)\[(saas-grid-column)\b(.*?)(?:(/))?\](?:(.+?)\[/\2\])?(.?)%si', SaaS::getThemeOption('pricingGridContent'), $parsedPlans);

if (!empty($parsedPlans[3]))
{
	foreach ($parsedPlans[3] as $planData)
	{
		$planAttr = shortcode_parse_atts($planData);
		
		if (isset($planAttr['title']) && $planAttr['link_url'] != 'disabled')
		{
			$plansList[$planAttr['title']] = $planAttr['title'];
		}
	}
}

// Selected Plan
$selectedPlan = filter_input(INPUT_GET, 'plan', FILTER_SANITIZE_SPECIAL_CHARS);

?>

<script src="http://ajax.aspnetcdn.com/ajax/jquery.validate/1.8.1/jquery.validate.min.js" type="text/javascript"></script>
<script type="text/javascript">
jQuery
(
	function($)
	{
	// validate the comment form when it is submitted
	$("#signupform").validate({
	  rules: {
	    email: {
		      required: true,
		      email: true
	    },
			password: {
			required: true,
			minlength: 5
		},
			password2: {
			required: true,
			minlength: 5,
			equalTo: "#password"
		},
			email2: {
			required: true,
			equalTo: "#email"
		},
		username: { 
	       required: true,
	       minlength: 2,
	       remote: "<?php bloginfo('template_url') ?>/users.php"
		}
	  },
		messages: {
	     username: {remote:"Username taken"},
		terms: "*"
	}
	});
	
	$('#signupform').submit(function() {
	  	//alert($('#plan option:selected').val());
		if ($('#plan option:selected').val() == "Free Trial")
		{
			$('#signupform').get(0).setAttribute('action', '<?php bloginfo('template_url') ?>/form-sign-up-submit.php?trial=yes');
			return true;
	  	}else if ($('#plan option:selected').val() == "Relocation"){
			$('#signupform').get(0).setAttribute('action', '/paypal');
			return true;
		}
	})
	
	$('#plan').change(function() {
	  	// alert($("#plan option:selected").val());
		$('#discount_code_li').hide('fast');
		
		if ($("#plan option:selected").val() == 1)
		{
			$('#discount_code_li').show('fast');
		}if ($("#plan option:selected").val() == 2){
			$('#discount_code_li').show('fast');
		}if ($("#plan option:selected").val() == 3){
			$('#discount_code_li').show('fast');
		}else{
			$('#discount_code').val('');
		}
	});
	
	if ($("#plan option:selected").val() == 1)
	{
		$('#discount_code_li').show();
	}if ($("#plan option:selected").val() == 2)
	{
		$('#discount_code_li').show();
	}if ($("#plan option:selected").val() == 3)
	{
		$('#discount_code_li').show();
	}/* else{
		$('#discount_code_li').hide();
	} */
	
	$('#hear_about_us').change(function() {
	  	// alert($("#plan option:selected").val());
		$('#hear_about_us_other').hide('fast');
		
		if ($("#hear_about_us option:selected").val() == 'Other')
		{
			$('#hear_about_us_other').show('fast');
		}else{
			$('#hear_about_us_other').val('');
		}
	});
	
	
	$('#hear_about_us_other').hide();
	
	
});








</script>

<script type="text/javascript">
 var RecaptchaOptions = {
    theme : 'white'
 };
 </script>

<div class="m2p-steps m2p-registration">
<div class="testimonials">
	<div>
	<ul>
		<li>
			<div class="avatar">
				<h2>1</h2>
			</div>
			<div class="testiContent">
				
				<h3>Complete our quick form</h3>
			
<form class="signupform" method="post" id="signupform" action="<?php bloginfo('template_url') ?>/form-sign-up-submit.php">
	
	<h5><?php esc_html_e('Pricing Plan', 'saas') ?> <em><?php esc_html_e('(* Indicates required information)', 'saas') ?></em></h5>
	<ul>
		<li>
			<label class="plan" for="plan"><?php esc_html_e('Plan', 'saas') ?>:</label>
			<select	class="plan" id="plan" name="plan">
				<option <?php  selected(1, $_GET['plan']); ?> value="1">1 Month Plan - $19 P/M</option>
				<option <?php echo selected(2, $_GET['plan']); ?> value="2">6 Month Plan - $75</option>
				<option <?php echo selected(3, $_GET['plan']); ?> value="3">12 Month Plan - $115</option>
			</select>
			<em>*</em>
		</li>
	</ul>
	<h5><?php esc_html_e('Account Information', 'saas') ?></h5>
	<ul>
		<li>
			<label for="username">Create Username:</label>
			<input maxlength="50" id="username" name="username" type="text" class="required" />
			<em>*</em>
		</li>
		<li>
			<label for="password">Create Password:</label>
			<input maxlength="50" id="password" name="password" type="password" class="required" />
			<em>*</em>
		</li>
		<li>
			<label for="password2">Reconfirm Password:</label>
			<input maxlength="50" id="password2" name="password2" type="password" class="required" />
			<em>*</em>
	
		</li>
		<li>
		&nbsp;
		</li>
		<li>
			<label for="firstName"><?php esc_html_e('First Name', 'saas') ?>:</label>
			<input maxlength="50" id="firstName" name="firstName" type="text" class="required" />
			<em>*</em>
		</li>
		<li>
			<label for="lastName"><?php esc_html_e('Last Name', 'saas') ?>:</label>
			<input maxlength="50" id="lastName" name="lastName" type="text" class="required" />
			<em>*</em>
		</li>
			
		<li>
			<label for="email"><?php esc_html_e('Email Address', 'saas') ?>:</label>
			<input maxlength="50" id="email" name="email" type="text" class="required" />
			<em>*</em>
		</li>
		<li>
			<label for="email2">Reconfirm Email:</label>
			<input maxlength="50" id="email2" name="email2" type="text" class="required" />
			<em>*</em>
		</li>
		<!--
		<li>
			<label for="street"><?php esc_html_e('Street Address', 'saas') ?>:</label>
			<input class="required" maxlength="100" id="street" name="street" type="text" />
			<em>*</em>
		</li>
		-->
		<li>
			<label for="city"><?php esc_html_e('City', 'saas') ?>:</label>
			<input class="required" maxlength="50" id="city" name="city" type="text" />
			<em>*</em>
		</li>
		<!--
		<li>
			<label for="zip"><?php esc_html_e('ZIP', 'saas') ?>:</label>
			<input class="zip required" maxlength="10" id="zip" name="zip" type="text" />
			<em>*</em>
		</li>

		<li>	
			<label for="state"><?php esc_html_e('State', 'saas') ?>:</label>
			<select	class="state required" id="state" name="state">
				<option value=""><?php esc_html_e('Select State', 'saas') ?></option>
			</select>
			<em>*</em>
		</li>
		-->
		<li>
			<label for="country"><?php esc_html_e('Country', 'saas') ?>:</label>
			<select class="country required" id="country" name="country">
				<option value="" selected="selected">- please select -</option>
				<?php 

				// Connect to Mysql
				$db =  mysql_connect(M2P_APP_HOST, M2P_APP_USER, M2P_APP_PASS) 
				      or die('Could not connect: ' . mysql_error());
					//Select the correct database.
					mysql_select_db(M2P_APP_DB,$db)
					    or die ("Could not select database");
				

				$query = "SELECT * FROM country";
				$result = mysql_query($query);
				if (!$result) {
				    die('Invalid query: ' . mysql_error());
				}

				while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) 
				{
					?>
					<option value="<?=$row['code']?>"><?=$row['name']?></option>
					<?php
				}
				?>
			</select>
			<em>*</em>
		</li>
<!--
		<li>	
			<label for="phone"><?php esc_html_e('Phone', 'saas') ?>:</label>
			<input class="phone required" maxlength="20" id="phone" name="phone" type="text" />
			<em>*</em>
		</li>
	-->	
	<li>&nbsp;</li>	
		<li id="discount_code_li">	
			<label for="phone"><?php esc_html_e('Discount Code', 'saas') ?>:</label>
			<input class="discount_code " maxlength="20" id="discount_code" name="discount_code" type="text" />
		</li>
		<li>
			<label class="hear_about_us" for="hear_about_us" style="height:none;line-height:14px">Where Did You Hear About Us?:</label>
			<select	class="hear_about_us" id="hear_about_us" name="hear_about_us">
				<option value="Internet Search">Internet Search</option>
				<option value="Linkedin">Linkedin</option>
				<option value="Facebook">Facebook</option>
				<option value="Twitter">Twitter</option>
				<option value="Advertisement">Advertisement</option>
				<option value="Other">Other</option>
			</select>
		</li>
		<li id="hear_about_us_other">
			<label class="hear_about_us_other" for="hear_about_us_other">Other:</label>
			<input class="hear_about_us_other" maxlength="20" id="hear_about_us_other" name="hear_about_us_other" type="text" />
		</li>
			<li>
			&nbsp;
			</li>
		<li class="terms">	
			<input type="checkbox" id="terms" name="terms" value="terms" style="width:20px;margin-left:140px;" class="required"> I have read and agree to the <a href="/terms_of_use_agreement" target="_blank">Terms of Use Agreement</a>
			
		</li>
		<li>
			<?php
			          require_once('recaptchalib.php');
			          $publickey = "6LcU4MoSAAAAAFx3iOCDTy_yw9MWmVyCiJiKKcMQ"; // you got this from the signup page
			          echo recaptcha_get_html($publickey);
			        ?>
			
		</li>
		<li>
			<br />
			<?php echo do_shortcode('[saas-button text="' . esc_attr__('Submit', 'saas') . '"]') ?>
			
		</li>
		
	</ul>
	<!--
	<h5><?php esc_html_e('Secure Payment Info', 'saas') ?></h5>
	<ul>
		<li>
			<label for="ccType"><?php esc_html_e('Credit Card', 'saas') ?>:</label>
			<select class="cctype" id="ccType" name="ccType">
				<option value="Visa"><?php esc_html_e('Visa', 'saas') ?></option>
			</select>
			<em>*</em>
			<img src="<?php bloginfo('template_url') ?>/images/order-cc.png" alt="<?php esc_attr_e('Credit Card', 'saas') ?>" />
		</li>
		<li>
			<label for="ccNumber"><?php esc_html_e('Card Number', 'saas') ?>:</label>
			<input class="ccnumber" maxlength="16" id="ccNumber" name="ccNumber" type="text" />
			<em>*</em>
			
			<label class="expires" for="ccExpMonth"><?php esc_html_e('Expires', 'saas') ?>:</label>
			<input class="expires" maxlength="2" id="ccExpMonth" name="ccExpMonth" type="text" />
			<span>/</span>
			<input class="expires" maxlength="4" id="ccExpYear" name="ccExpYear" type="text" />
			<em>*</em>
		</li>
		
		<li>
			<label for="ccCvv"><?php esc_html_e('CVV', 'saas') ?>:</label>
			<input class="cvv" maxlength="4" id="ccCvv" name="ccCvv" type="text" />
			<em>*</em>
			<img src="<?php bloginfo('template_url') ?>/images/order-cvv.png" alt="<?php esc_attr_e('CVV', 'saas') ?>" />
		</li>
		
		<li>
			
		</li>
	</ul>
	-->
</form>
<br style="clear: both;" />
			</div>
		</li>
		<li>
				<div class="avatar">
					<h2>2</h2>
				</div>
				<div class="testiContent">
					<h3>Finalise payment via secure site </h3>
<p style="clear:left">You will be redirected to PayPal, however do not need a PayPal account to pay with a credit or debit card.</p>	
				</div>
				<br style="clear: both;" />
				<br />
				
		</li>
		<li>
				<div class="avatar">
					<h2>3</h2>
				</div>
				<div class="testiContent">
					<h3>Receive your member confirmation email with log on details </h3>
					<p style="clear:left">Please add contact@moving2plan.com.au to your address book to ensure email communications are not sent to your junk or spam folder. Please ensure you have the latest version of your internet browser for optimum viewing.</p>
				</div>
				<br style="clear: both;" />
				<br />
		</li>
	</ul>
	</div>
</div>
</div>