<?php
/**
 * @package WordPress
 * @subpackage SaaS_I_Theme
 *
 * Copyright (c) 2010 WorryFreeLabs
 *
 * This file is part of SaaS I WordPress theme
 */


/**
 * This is for use throughout this application just to make thing a bit easier on  
 *
*/

require_once('db-creds.php');

/**
 * Translation
 */
load_theme_textdomain('saas', TEMPLATEPATH . '/languages');


/**
 * Theme initialization
 */
require_once 'library/SaaS.php';
SaaS::init(__FILE__);


/**
 * RSS
 */
add_theme_support('automatic-feed-links');


/**
 * Sidebar
 */
if (function_exists('register_sidebar'))
{
	register_sidebar(array(
		'before_widget' => '<div id="%1$s" class="widget %2$s">',
		'after_widget' => '</div>',
		'before_title' => '<h2>',
		'after_title' => '</h2>',
	));
}


/**
 * Thumbnails
 */
add_theme_support('post-thumbnails');


/**
 * Menus
 */
register_nav_menu('main', __('Main Nav', 'saas'));
register_nav_menu('top', __('Top Links', 'saas'));


/** 
 * Require our sidebar library and shortcodes
 */

require_once 'library/m2p-sidebar.php';
require_once 'library/m2p-shortcodes.php';