<?php
/**
 * @package WordPress
 * @subpackage SaaS_I_Theme
 *
 * Copyright (c) 2010 WorryFreeLabs
 *
 * This file is part of SaaS I WordPress theme
 */

get_header() ?>
				<div class="page-title">
					<h2><?php the_title() ?></h2>
				</div>
			</div>
		</div>
	</div>
</div>
<!--div.header end -->

<div class="container">
	<div class="center">
		<?php get_sidebar() ?>
		<div id="content" class="col-main">
			<?php
			$news = get_term_by('slug', 'news', 'category' );
			
			query_posts('cat=' . $news->term_id); ?>
			<?php if (have_posts()): $post = $posts[0]; // Hack. Set $post so that the_date() works. ?>
				
				<h2><?php esc_html_e('News', 'saas') ?></h2>
		
				<?php while (have_posts()): the_post() ?>
					<div <?php post_class() ?>>
						
						<div>
							<h3><a href="<?php the_permalink() ?>" rel="bookmark" title="<?php printf(esc_attr__('Permanent Link to %s', 'saas'), the_title_attribute('echo=0')) ?>"><?php the_title() ?></a></h3>
							<div class="postmeta">
								<!--<div class="comment-stats right"><?php comments_popup_link(__('0 Comments', 'saas'), __('1 Comment', 'saas'), __('% Comments', 'saas')) ?></div> -->
								<div class="tags"><?php printf(__('Posted on <strong>%1$s</strong> in %2$s', 'saas'), get_the_time('F j, Y'), get_the_category_list(', ')) ?></div>
							</div>
							<div class="entry">
								<?php the_excerpt() ?>
								<p><a href="<?php the_permalink() ?>" class="keep-reading" rel="bookmark" title="<?php printf(esc_attr__('Permanent Link to %s', 'saas'), the_title_attribute('echo=0')) ?>"><?php esc_html_e('Keep Reading', 'saas') ?></a></p>
							</div>
						</div>
					</div>
				<?php endwhile ?>
		
				<?php if (function_exists('wp_pagenavi')):?>
					<?php wp_pagenavi() ?>
				<?php else: ?>
					<div class="navigation">
						<div class="alignleft">
							<?php next_posts_link(__('&laquo; Older Entries', 'saas')) ?>
						</div>
						<div class="alignright">
							<?php previous_posts_link(__('Newer Entries &raquo;', 'saas')) ?>
						</div>
					</div>
				<?php endif ?>
	
			<?php else: ?>
				
				<div class="post">
					<?php if (is_category()): // If this is a category archive ?>
						<h2><?php printf(__('Sorry, but there aren\'t any posts in the %s category yet.', 'saas'), single_cat_title('', false)) ?></h2>
					<?php elseif (is_date()): // If this is a date archive ?>
						<h2><?php esc_html_e('Sorry, but there aren\'t any posts with this date.', 'saas') ?></h2>
					<?php elseif (is_author()): // If this is a category archive ?>
						<?php $userdata = get_userdatabylogin(get_query_var('author_name')) ?>
						<h2 class="center"><?php printf(__('Sorry, but there aren\'t any posts by %s yet.', 'saas'), $userdata->display_name) ?></h2>
					<?php else: ?>
						<h2 class="center"><?php esc_html_e('No posts found.', 'saas') ?></h2>
					<?php endif ?>
					
					<div class="widget widget_search">
						<?php echo get_search_form() ?>
					</div>
				</div>
				
			<?php endif ?>
		</div>

<?php get_footer() ?>