<?php
/*
---------------------------------------------------------------------
Credits: Bit Repository

Source URL: http://www.bitrepository.com/resize-an-image-keeping-its-aspect-ratio-using-php-and-gd.html
---------------------------------------------------------------------
*/
class Resize_Image {

var $image_to_resize;
var $new_width;
var $new_height;
var $ratio;
var $new_image_name;
var $save_folder;

function resize()
{
    if(!file_exists($this->image_to_resize))
    {
      exit("File ".$this->image_to_resize." does not exist.");
    }

    $info = GetImageSize($this->image_to_resize);

    if(empty($info))
    {
      exit("the file ".$this->image_to_resize." doesn't seem to be an image");
    }
    


    $width_orig = $info[0];
    $height_orig = $info[1];
    $mime = $info['mime'];

    /*
    Keep Aspect Ratio?

    Improved, thanks to Larry
    */
    
    $thumbnail_width = $this->new_width;
    $thumbnail_height = $this->new_height;

    if($this->ratio)
    {
        $ratio_orig = $width_orig/$height_orig;
       
        if ($thumbnail_width/$thumbnail_height > $ratio_orig) {
           $new_height = $thumbnail_width/$ratio_orig;
           $new_width = $thumbnail_width;
        } else {
           $new_width = $thumbnail_height*$ratio_orig;
           $new_height = $thumbnail_height;
        }
       
        $x_mid = $new_width/2;  //horizontal middle
        $y_mid = $new_height/2; //vertical middle
        
        
        // if preserving the ratio, only new width or new height
    // is used in the computation. if both
    // are set, use width
    /*
     $screenRatio = $this->new_width / $this->new_hight;
     $imageRatio = $width / $height;
     
     if($imageRatio > $screenRatio)
     {

        $this->new_width = $this->new_width;
        $this->new_height = ($this->new_width/$width)*$height;
     }
     else
     {
        $this->new_width = ($this->new_height/$height)*$width;
        $this->new_height = $this->new_height;
     }
    
      
     if (isset($this->new_width))
     {
     $factor = (float)$this->new_width / (float)$width;
     $this->new_height = $factor * $height;
    }
    else if (isset($this->new_height))
    {
    $factor = (float)$this->new_height / (float)$height;
    $this->new_width = $factor * $width;
    }
    else
    exit("neither new height or new width has been set");
    */
    }
    
    // What sort of image?

    $type = substr(strrchr($mime, '/'), 1);

    switch ($type)
    {
    case 'jpeg':
        $image_create_func = 'ImageCreateFromJPEG';
        $image_save_func = 'ImageJPEG';
        $new_image_ext = 'jpg';
        break;

    case 'png':
        $image_create_func = 'ImageCreateFromPNG';
        $image_save_func = 'ImagePNG';
        $new_image_ext = 'png';
        break;

    case 'bmp':
        $image_create_func = 'ImageCreateFromBMP';
        $image_save_func = 'ImageBMP';
        $new_image_ext = 'bmp';
        break;

    case 'gif':
        $image_create_func = 'ImageCreateFromGIF';
        $image_save_func = 'ImageGIF';
        $new_image_ext = 'gif';
        break;

    case 'vnd.wap.wbmp':
        $image_create_func = 'ImageCreateFromWBMP';
        $image_save_func = 'ImageWBMP';
        $new_image_ext = 'bmp';
        break;

    case 'xbm':
        $image_create_func = 'ImageCreateFromXBM';
        $image_save_func = 'ImageXBM';
        $new_image_ext = 'xbm';
        break;

    default:
        $image_create_func = 'ImageCreateFromJPEG';
        $image_save_func = 'ImageJPEG';
        $new_image_ext = 'jpg';
    }

    
    $myImage = imagecreatefromjpeg($this->image_to_resize);
    
    $process = imagecreatetruecolor(round($new_width), round($new_height));
   
    imagecopyresampled($process, $myImage, 0, 0, 0, 0, $new_width, $new_height, $width_orig, $height_orig);
    $thumb = imagecreatetruecolor($thumbnail_width, $thumbnail_height);
    imagecopyresampled($thumb, $process, 0, 0, ($x_mid-($thumbnail_width/2)), ($y_mid-($thumbnail_height/2)), $thumbnail_width, $thumbnail_height, $thumbnail_width, $thumbnail_height);

    if($this->new_image_name)
           {
                $new_name = $this->new_image_name.'.'.$new_image_ext;
           }
           else
           {
                $new_name = $this->new_thumb_name( basename($this->image_to_resize) ).'_resized.'.$new_image_ext;
           }

           $save_path = $this->save_folder.$new_name;
           
    
    $save_path = $this->save_folder.$new_name;

           header("Content-Type: ".$mime);

           $image_save_func($thumb, NULL, 60);
      
        
        
        $process = $image_save_func($thumb, $save_path, 60);

        return array('result' => $process, 'new_file_path' => $save_path);
    
    imagedestroy($process);
    imagedestroy($myImage);
    //return $thumb;
    // New Image
    /*
    $image_c = ImageCreateTrueColor($this->new_width, $this->new_height);

    $new_image = $image_create_func($this->image_to_resize);

    ImageCopyResampled($image_c, $new_image, 0, 0, 0, 0, $this->new_width, $this->new_height, $width, $height);
    


           if($this->new_image_name)
           {
                $new_name = $this->new_image_name.'.'.$new_image_ext;
           }
           else
           {
                $new_name = $this->new_thumb_name( basename($this->image_to_resize) ).'_resized.'.$new_image_ext;
           }

           $save_path = $this->save_folder.$new_name;

           header("Content-Type: ".$mime);

           $image_save_func($image_c, NULL, 60);
      
        
        
        $process = $image_save_func($image_c, $save_path, 60);

        return array('result' => $process, 'new_file_path' => $save_path);
        */
    }

    function new_thumb_name($filename)
    {
    $string = trim($filename);
    $string = strtolower($string);
    $string = trim(ereg_replace("[^ A-Za-z0-9_]", " ", $string));
    $string = ereg_replace("[ tnr]+", "_", $string);
    $string = str_replace(" ", '_', $string);
    $string = ereg_replace("[ _]+", "_", $string);

    return $string;
    }
}
?>